![Material](http://www.cosmicmind.io/MK/Material.png)

# Welcome to Material

An animation and graphics framework for Material Design in Swift.

![App](http://www.cosmicmind.io/gifs/App.gif)

## Features

- [x] Fully Configurable UI Components
- [x] Grid System For Complex UIs
- [x] Layout Library To Simplify AutoLayout
- [x] Base Material Layers & Material Views To Create New UI Components
- [x] Navigation Controls
- [x] Material Buttons
- [x] Material Switch
- [x] Material Card Views
- [x] Material Icons
- [x] Menu Toolset To Create Animated Menus
- [x] Camera / Video Extension With Extensive Functionality
- [x] Animation Extension To Create Intricate Animations
- [x] Complete Material Color Library
- [x] Example Projects
- [x] And More...

## Requirements

* iOS 8.0+ / Mac OS X 10.9+
* Xcode 7.3+

## Communication

- If you **need help**, use [Stack Overflow](http://stackoverflow.com/questions/tagged/cosmicmind). (Tag 'cosmicmind')
- If you'd like to **ask a general question**, use [Stack Overflow](http://stackoverflow.com/questions/tagged/cosmicmind).
- If you **found a bug**, _and can provide steps to reliably reproduce it_, open an issue.
- If you **have a feature request**, open an issue.
- If you **want to contribute**, submit a pull request.

## Installation

> **Embedded frameworks require a minimum deployment target of iOS 8 or OS X Mavericks (10.9).**
> - [Download Material](https://github.com/CosmicMind/Material/archive/master.zip)

Visit the [Installation](https://github.com/CosmicMind/Material/wiki/Installation) page to learn how to install Material using [CocoaPods](http://cocoapods.org) and [Carthage](https://github.com/Carthage/Carthage).

## Changelog

Material is a growing project and will encounter changes throughout its development. It is recommended that the [Changelog](https://github.com/CosmicMind/Material/wiki/Changelog) be reviewed prior to updating versions.

## Examples

* Visit the Examples directory to see example projects using Material.
* The [Installation](https://github.com/CosmicMind/Material/wiki/Installation) page has documentation on how to run the example projects.

## Sticker Sheet

To help template your project, checkout Material Sticker Sheet.

![MaterialStickerSheet](http://www.cosmicmind.io/MK/material_iso_1.png)

[Get Material Sticker Sheet](http://www.materialup.com/posts/material-design-sticker-sheets)

## Material Colors

Try the Material Colors app to see the wonderful colors available in Material, or use the online version at [MaterialColors.io](http://materialcolors.io)

![MaterialColors](http://www.cosmicmind.io/gifs/MaterialColors.gif)

[Get Material Colors on the AppStore](https://itunes.apple.com/app/x/id1111994400?mt=8)

## A Quick Tour

Take a look at some components in Material.

#### Material Icons

Material Icons is a library of Google and CosmicMind icons that are available for use within your iOS applications. To help with icon choices, visit [MaterialIcon.io](http://www.materialicon.io).

![MaterialIcon](http://www.cosmicmind.io/MK/MaterialMaterialIcon.png)

#### TextField

A TextField is an excellent way to improve UX.

![TextField](http://www.cosmicmind.io/gifs/TextField.gif)

#### Buttons

Some example buttons - FlatButton, RaisedButton, FabButton, and IconButton.

![Buttons](http://www.cosmicmind.io/gifs/Buttons.gif)

#### MenuView

A MenuView manages a group of UIViews that may be animated with default and custom configurations.

![MenuView](http://www.cosmicmind.io/gifs/MenuView.gif)

#### Material Switch

Enjoy flexible switch controls to add that little extra to your application.

![Switch](http://www.cosmicmind.io/gifs/Switch.gif)

#### Grid

Grid is an extension of UIView that enables any collection of subviews to be managed in a flexible grid system.

![Grid](http://www.cosmicmind.io/gifs/Grid.gif)

#### CardViews

CardViews are flexible components that may be configured in any way you like.

![CardView](http://www.cosmicmind.io/gifs/CardView.gif)

![ImageCardView](http://www.cosmicmind.io/gifs/ImageCardView.gif)

![TableCardView](http://www.cosmicmind.io/gifs/TableCardView.gif)

#### Toolbar

Toolbars are super flexible and add excellent control to your navigation flow.

![Toolbar](http://www.cosmicmind.io/gifs/Toolbar.gif)

#### SearchBar

SearchBars are sleek and powerful. Customize a SearchBar in any way you like.

![SearchBar](http://www.cosmicmind.io/gifs/SearchBar.gif)

#### Much More...

So much more inside. Enjoy!

## License

Copyright (C) 2015 - 2016, Daniel Dahan and CosmicMind, Inc. <http://cosmicmind.io>. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

*   Redistributions of source code must retain the above copyright notice, this     
    list of conditions and the following disclaimer.

*   Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

*   Neither the name of Material nor the names of its
    contributors may be used to endorse or promote products derived from
    this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
